﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        EventsAreEnabled = False
        InitPanels()
        Load_INI()
        InitParams()
        InitDrawing()
        InitDrawingParams()
        DataArray1.LoadLastBuffer()
        UpdateAllPanels()
        FastTimer_Start()
        Timer1.Interval = 20
        Timer1.Start()
        EventsAreEnabled = True
        ResizeDimensions(Pbox1)
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False
        DataArray1.SaveLastBuffer()
        FastTimer_Stop()
        Timer1.Stop()
        Save_INI()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Exit Sub
        UpdateAllPanels()
        ResizeDimensions(Pbox1)
    End Sub

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        If Not EventsAreEnabled Then Exit Sub
        ResizeDimensions(Pbox1)
    End Sub

    Private Sub SetDefaultFocus()
        Label1.Focus()
    End Sub

    ' ========================================================================================================
    '   COMMANDS
    ' ========================================================================================================
    Private Sub btn_LoadBuffer_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_LoadBuffer.ClickButtonArea
        DataArray1.LoadBuffer_Dialog()
        UpdateImage = True
    End Sub
    Private Sub btn_SaveBuffer_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SaveBuffer.ClickButtonArea
        DataArray1.SaveBuffer_Dialog()
    End Sub
    Private Sub btn_ResetDimensions_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ResetDimensions.ClickButtonArea
        ResetDimensions()
        UpdateImage = True
    End Sub
    Private Sub btn_Restart_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Restart.ClickButtonArea
        InitDrawing()
        UpdateImage = True
    End Sub

    ' ========================================================================================================
    '   MOUSE DRAG and ZOOM
    ' ========================================================================================================
    Private MouseStartX As Single
    Private MouseStartY As Single
    Private MousePressed As Boolean
    Private Sub Pbox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pbox1.MouseDown
        MouseStartX = e.X
        MouseStartY = e.Y
        MousePressed = True
    End Sub
    Private Sub Pbox1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pbox1.MouseUp
        MousePressed = False
    End Sub
    Private Sub Pbox1_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Pbox1.MouseLeave
        StatusLabel1.Text = ""
    End Sub
    Private Sub Pbox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pbox1.MouseMove
        If MousePressed Then
            StartX -= e.X - MouseStartX
            StartY += e.Y - MouseStartY
            MouseStartX = e.X
            MouseStartY = e.Y
            UpdateImage = True
        Else
            Dim Xmm As Single = PixelXtoMM(e.X)
            Dim Ymm As Single = PixelYtoMM(e.Y)

            StatusLabel1.Text = ("X = " + Xmm.ToString("0", GCI) + " mm").PadRight(11) + _
                                ("Y = " + Ymm.ToString("0", GCI) + " mm").PadRight(11)

            FindArrayIndex(Xmm, Ymm)
            StatusLabel1.Text += DecodeInfoFromIndex()
        End If
    End Sub
    Private Sub Pbox1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Pbox1.MouseWheel
        Dim delta As Single = e.Delta * 0.001F
        ChangeZoom(delta, e.X, e.Y)
    End Sub

    ' ========================================================================================================
    '   KEYS
    ' ========================================================================================================
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        Select Case e.KeyCode
            Case Keys.Right
                If SelectedIndex < DataArray1.GetNumEntries - 1 Then SelectedIndex += 1
                UpdateImage = True
            Case Keys.Left
                If SelectedIndex > 0 Then SelectedIndex -= 1
                UpdateImage = True
        End Select
        StatusLabel1.Text = DecodeInfoFromIndex()
    End Sub



    ' ========================================================================================================
    '   SAVE PARAMS ON LOST-FOCUS
    ' ========================================================================================================
    Private Sub Params_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles txt_WireDiam.LostFocus, _
                                                                            txt_NeedleDiam.LostFocus, _
                                                                            txt_SewingAreaMaxY.LostFocus, _
                                                                            txt_SewingAreaMinY.LostFocus, _
                                                                            txt_SewingAreaMaxX.LostFocus, _
                                                                            txt_SewingAreaMinX.LostFocus, _
 _
                                                                            chk_ScaleText.LostFocus, _
                                                                            chk_TrueXYZ.LostFocus, _
                                                                            txt_SlotX.LostFocus, _
                                                                            txt_SlotY.LostFocus, _
                                                                            txt_SlotZ.LostFocus, _
                                                                            txt_SlotRestart.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub Params_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles txt_WireDiam.TextChanged, _
                                                                            txt_NeedleDiam.TextChanged, _
                                                                            txt_SewingAreaMaxY.TextChanged, _
                                                                            txt_SewingAreaMinY.TextChanged, _
                                                                            txt_SewingAreaMaxX.TextChanged, _
                                                                            txt_SewingAreaMinX.TextChanged, _
 _
                                                                            chk_ScaleText.CheckedChanged, _
                                                                            chk_TrueXYZ.CheckedChanged, _
                                                                            txt_SlotX.TextChanged, _
                                                                            txt_SlotY.TextChanged, _
                                                                            txt_SlotZ.TextChanged, _
                                                                            txt_SlotRestart.TextChanged
        If Not EventsAreEnabled Then Return
        InitParams()
        Me.Refresh()
    End Sub

    Private Sub InitParams()
        WireDiam = CSng(txt_WireDiam.NumericValue)
        NeedleDiam = CSng(txt_NeedleDiam.NumericValue)
        If WireDiam < 0.1 Then WireDiam = 0.1
        If NeedleDiam < 0.1 Then NeedleDiam = 0.1
        InitDrawingParams()
        ' -----------------------------------------------
        SewingAreaMaxY = txt_SewingAreaMaxY.NumericValueInteger
        SewingAreaMinY = txt_SewingAreaMinY.NumericValueInteger
        SewingAreaMaxX = txt_SewingAreaMaxX.NumericValueInteger
        SewingAreaMinX = txt_SewingAreaMinX.NumericValueInteger
        FlagScaleText = chk_ScaleText.Checked
        FlagTrueXYZ = chk_TrueXYZ.Checked
        ' -----------------------------------------------
        SlotX = txt_SlotX.NumericValueInteger
        SlotY = txt_SlotY.NumericValueInteger
        SlotZ = txt_SlotZ.NumericValueInteger
        SlotRestart = txt_SlotRestart.NumericValueInteger
        ' -----------------------------------------------
        UpdateImage = True
        Timer1_Tick(Nothing, Nothing)
        Pbox1.Select()
    End Sub


    ' ===================================================================================================
    '  PANELS 
    ' ===================================================================================================
    Private PanelHeight(3) As Int32

    Private Sub InitPanels()
        PanelHeight(1) = GroupBox1.Height
        PanelHeight(2) = GroupBox2.Height
        PanelHeight(3) = GroupBox3.Height
    End Sub

    Private Sub GroupBox_Click(ByVal sender As Object, ByVal e As EventArgs) Handles GroupBox1.Click, _
                                                                                     GroupBox2.Click, _
                                                                                     GroupBox3.Click
        Dim gbox As GroupBox = CType(sender, GroupBox)
        If gbox.PointToClient(MousePosition).Y > 20 Then Return
        ToggleGboxHeight(gbox)
        UpdateAllPanels()
    End Sub

    Private Sub ToggleGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height > 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub SetGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height <= 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub UpdateAllPanels()
        If Me.WindowState = FormWindowState.Minimized Then Return
        ' --------------------------------------- Ensure the correct height also if INI is not ok
        SetGboxHeight(GroupBox1)
        SetGboxHeight(GroupBox2)
        SetGboxHeight(GroupBox3)
        ' --------------------------------------- Set the vertical positions
        GroupBox2.Top = GroupBox1.Bottom + 6
        GroupBox3.Top = GroupBox2.Bottom + 6
        ' --------------------------------------- Set the Form minimum height
        Dim topSize As Int32 = Me.Size.Height - Me.ClientSize.Height
        Dim MinHeight As Int32 = GroupBox3.Bottom + topSize + 150
        If MinHeight < 100 Then MinHeight = 100
        Me.MinimumSize = New Size(Me.MinimumSize.Width, MinHeight)
    End Sub

    ' ========================================================================================================
    '   Update timer
    ' ========================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Static SlotRestartEnabled As Boolean
        If Slots.ReadSlot(SlotRestart) > 500 Then
            If SlotRestartEnabled Then
                SlotRestartEnabled = False
                InitDrawing()
                UpdateImage = True
            End If
        Else
            SlotRestartEnabled = True
        End If

        If UpdateImage Then
            UpdateImage = False
            DrawImage(Pbox1)
            Pbox1.Refresh()
        End If
    End Sub

End Class